/*   ---------===:::>>>>   RE-life
                            by Henrik 'carnalizer' Pettersson, (c)2013
*/

// GAME STATES *****************
final int STATE_SPLASH= 0;
final int STATE_MENU = 1;
final int STATE_GAME = 2;
final int STATE_PAUSED = 3;
int gameState = STATE_GAME;
final color WHITE = color(255,255,255);
final color BLACK = color(0,0,0);
final color GROBBLING = color(100,200,0);
final color POOP = color(120,70,50);
final color EGG = color(18,133,50);
final color SHROOM = color(250,100,50);
final color WATER = color(70,90,190);
final color BOMB = color(255,00,00);

float grobbSpeed=1;
float lethality = 1.7; //Higher means worse
float lifespan = 1.25; //Higher means shorter
float fertility = 0.47; //Higher means less
int grobblingCounter=0;

//boolean saved=true;
boolean showWaterTrail=false;
boolean showFoodTrail=false;
boolean showCollision=false;
boolean showHeat=false;
//PImage collisionMap;
PImage collisionMap;
PImage waterMap;
PImage foodMap;
PImage heatMap;
PImage background;
PImage buffer;
PImage multiSpriteMap;
PImage hole;
String outMessage="Go!";
int scrWidth=256, scrHeight=192;
boolean keyUp=false,keyDown=false,keyLeft=false,keyRight=false;
PFont font;
//Mob testMob= new Mob();
ArrayList mobs;
ArrayList anims;


void setup(){
  grobbSpeed=1;
  lethality = 1.7; //Higher means worse
  lifespan = 1.25; //Higher means shorter
  fertility = 0.47; //Higher means less
  grobblingCounter=0;
  randomSeed(0);
  noSmooth();
  anims = new ArrayList();
  font = loadFont("04b03-48.vlw");
  //collisionMap=loadImage("collisionMap.png");
  multiSpriteMap=loadImage("anims.png");
  buffer=loadImage("background.png");
  hole=loadImage("hole.png");
  collisionMap=loadImage("collisionMap.png");
  waterMap=loadImage("waterMap.png");
  foodMap=loadImage("foodMap.png");
  heatMap=loadImage("heatMap.png");
  background=loadImage("background.png");
  textFont(font);
  textSize(8);
  textAlign(CENTER);
  size(scrWidth*4,scrHeight*4,JAVA2D);
  background(20,20,10);
  
  mobs = new ArrayList();
  makeMobs();
  
}

void makeMobs(){
  for (int i = 0; i < 20; i++) {
    boolean lookingForSpot=true;
    float tryX=random(scrWidth*0.125);//+random(scrWidth*0.125);
    float tryY=random(scrHeight*0.125);//+random(scrHeight*0.125);
    while (lookingForSpot){
      tryX=random(scrWidth*0.17)+random(scrWidth*0.17);
      tryY=random(scrHeight*0.17)+random(scrHeight*0.17);
      if(collisionMap.get(int(tryX),int(tryY))==WHITE){
        lookingForSpot=false;
      }
    }
    mobs.add (new Mob(tryX,tryY,random(0.7)));
  }
}

